var num_comments = 0;


$(document).ready(function(){

	$("div#error").css("display", "none");
	
	$.get("get_is_logged.php", function(data){
		
		if(data == 0)
		{
			login();
		}
		else
		{
			loadPage();
		}
	
	});
});

function login()
{
	// generate a form for them to log in.  Since neither forms nor tables are part of vanilla jQuery, we just spit out the raw html required.  Yay hacks!
	$("div#login").html("<form id=\"loginform\"><table border=\"1px\"><tr><td><b>Username:</b></td><td> <input type=\"text\" id=\"username\" name=\"username\" /></td></tr><tr><td><b>Password:</b></td><td> <input type=\"password\" id=\"password\" name=\"password\" /></td></tr><tr><td></td><td><input type=\"submit\" id=\"submitbutton\" name=\"submitbutton\" class=\"bluebutton\" /></td></tr></table></form>");
	$("div#welcome").html("This is a login example that uses jQuery.  It's slicker than using 'login.php', 'login2.php', 'index.php' because it's all consolidated onto one dynamic page which never has to reload.");
	// define behavior for the parts of the form we just generated
	var user = $("#username");
	user.select(); // start the cursor in the username text field
	
	var pass = $("#password");
	var submit = $("#submitbutton");
	// clicking either text field should make the error tab disappear
	user.focus(function(event){
	
		$("div#error").css("display", "none");
	});
	// clicking either text field should make the error tab disappear
	pass.focus(function(event){
	
		$("div#error").css("display", "none");
	});
	
	// clicking the submit button:
	submit.click(function(event){		
	
		$.post("login.php", {username:user.val(), password:pass.val()}, function(data){
		
			if(!data)
			{
				$("div#error").css("display", "none");
				pass.val("");
				if(user.val() == "")
					user.val("\'arry.");
				$("div#error").html("Invalid login.  Yer clearly not a wizard, " + user.val() + ".");
				user.val("");
				$("div#error").slideDown("fast");
			}
		
			else
			{
				$("div#login").css("display", "none");
				$("div#error").css("display", "none");
				loadPage();
			}
		
		}, "json");
	
		return false;
		
	});
}
	
function loadPage()
{
	$.get("get_comments.php", function(data) {
	
		// since they've logged in, we generate the page for them and change the welcome text to greet them.
		var welcomeDiv = $("div#welcome");
		var pageDiv = $("div#page");
		pageDiv.css("display", "none"); // hide it.
		pageDiv.html(""); // set html to nothing -- we reassemble it from scratch each time.
		// if we didn't do this, refreshing the page might result in some weird duplication behavior... let's not go there.
		
		// or .text() if you don't need to have raw html formatting at your disposal
		welcomeDiv.html("Well done, an' welcome ta HOGWARTS! - <a href=\"logout.php\">Logout</a>");
		
		
		/* Define (length) behavior for form used to add new comments. */
		
		// comment form
		var commentFormDiv = $("<div>");
		commentFormDiv.attr("id", "commentformdiv");
		// generate a form for user to add new comments, duh!
		var commentForm = $("<form>");
		
		var commentNameDiv = $("<div>");
		commentNameDiv.text("Name: ");
		var commentName = $("<input>");
		commentName.attr("type", "text");
		commentName.val("Anonymous");
		
		commentName.click(function(){
		
			if(commentName.val() == "Anonymous")
			{
				commentName.val("");
			}
		
		});
		commentName.focusout(function(){
		
			if(commentName.val() == "")
			{
				commentName.val("Anonymous");
			}
		
		});
		
		commentNameDiv.append(commentName);
		
		// generate the "Add your own comment" bit
		var addComment = $("<textarea>");
		addComment.attr("rows", "5");
		addComment.attr("cols", "50");
		addComment.val("Write a comment");
		addComment.addClass("addcommentform");
		addComment.click(function(){
		
			if(addComment.val() == "Write a comment")
			{
				addComment.val("");
			}
		
		});
		addComment.focusout(function(){
		
			if(addComment.val() == "")
			{
				addComment.val("Write a comment");
			}
		
		});
		
		commentForm.append(commentNameDiv);
		// add the text input to the form
		commentForm.append(addComment);				
		// create button
		var commentSubmit = $("<input>");
		commentSubmit.attr("type", "button");
		commentSubmit.attr("value", "Add Comment");
		commentSubmit.addClass("bluebutton");
		// add button to the form
		var commentSubmitDiv = $("<div>");
		commentSubmitDiv.addClass("addcommentform");
		commentSubmitDiv.append(commentSubmit);
		commentForm.append(commentSubmitDiv);
		
		// list of comments
		var commentsDiv = $("<div>");
		commentsDiv.attr("id", "comments");
		
		// define the form's submission behavior
		commentSubmit.click(function(){
		
			if(addComment.val() == "" || addComment.val() == "Write a comment")
			{
				alert("Please enter a non-empty comment!");
				addComment.select();
				return false;
			}
			
			// if there's text in the field, add it as a comment.
			var commentText = addComment.val();
			var name = commentName.val();
			
			$.post("add_comment.php", {name:name, comment:commentText}, function(data2){
				var timestamp = "Moments ago...";
				var id = data2.id;
				
				commentsDiv = addNewComment(id, name, commentText, timestamp, commentsDiv);
				commentName.val("Anonymous");
				addComment.val("Write a comment");
			
			}, "json");
			

			return false;
		
		});
		// before we create the actual comments, attach the form for adding more.
		commentFormDiv.append(commentForm);
		
		
		
		/* Now define behavior for actually showing comments */
		
		if(data.length == 0)
		{
			commentsDiv.html("<i>No comments in the system at this time.</i>");
		}
		
		for(var i = 0; i < data.length; i++)
		{
			commentsDiv = addNewComment(data[i].id, data[i].name, data[i].comment, data[i].timestamp, commentsDiv);
			num_comments++;
		}
		
		pageDiv.append(commentFormDiv);
		pageDiv.append(commentsDiv);
		pageDiv.slideDown('slow');
		
	}, "json");
	
	
}

function addNewComment(id, name, comment, timestamp, commentsDiv)
{
	if(num_comments == 0)
	{
		commentsDiv.html("");
	}

	var newCommentDiv = $("<div>");
	newCommentDiv.addClass("comment");
	newCommentDiv.attr("id", id);
	newCommentDiv.html("<br>" + name + " wrote:<br><br>\"" + comment + "\"<br><br>" + timestamp + "<br>");
	newCommentDiv.click(function(){
	
		// delete this comment
		$.post("delete_comment.php", {id:newCommentDiv.attr("id")});
		newCommentDiv.slideUp('slow');
		num_comments--;
		if(num_comments == 0)
		{
			commentsDiv.html("<i>No comments in the system at this time.</i>");
		}

	});
	commentsDiv.append(newCommentDiv);
	num_comments++;
	return commentsDiv;
}